/*
 * $Id: //depot/prod/kamino/main/util/viewServerInfo/src/ViewServerCmnd.h#3 $
 *
 * Copyright (c) 2008 NetApp, Inc.
 * All rights reserved.
 */

#include "ViewDesktopSource.h"
#include "ViewPool.h"

#include <windows.h>
#include <winldap.h>
#include <stdio.h>
#include <stdlib.h>
#include <dsgetdc.h>
#include <lm.h>
#include <vector>
#include <map>
#include <string>

using namespace std;

class ViewServerCmnd
{
private:
    const static int DEBUG = true;
    static int bind(char* host, char* ntLogon, char* password, LDAP *&ld);
    static int unbind(LDAP *&ld);

    static int addVM(ViewDesktopSource *desktopSource, LDAP *&ld);
    static int addServerGroup(int accessMode, string serverGroupName, vector<ViewDesktopSource*> &desktopSources,
        LDAP *&ld, char* vcdn);
    static int addToExistingServerGroup(string poolName, vector<ViewDesktopSource*> &desktopSources, LDAP *&ld);
    static int addApplication(string applicationName, LDAP *&ld);
public:
    ViewServerCmnd();
    ~ViewServerCmnd();
    static int ValidateCredentials(char* host, char* ntLogon, char* password);
    static int GetVirtualCenterGUID(char* host, char* ntLogon, char* password, vector<string> &addresses, char* dn);
	static int GetPools(char* host, char* ntLogon, char* password, boolean manualPoolsOnly, vector<ViewPool*> &pools);
    static int ImportPool(char* host, char* ntLogon, char* password, vector<string> &addresses, int accessMode, int poolType,
    		map<string, vector<ViewDesktopSource*> > &desktopSourceMap);
};
